hirom

header

;-----------CODE SOURCE and SPRITE GFX
; 10f300-10fff: free space in both TQ/FQ; map1/map2
; 11f300-11fff: lanmolas tiles (use bosses_cgx.ips)
; 12f300-12fff: Gleeok tiles (use bosses_cgx.ips


;----------- inits the sprite, lanmola use Stalfos as base
; d1: 1 Head (invincible), d2: 6 Segments (invincible), d3: 1 hitable last segment, d4: head if only head left (hitable)
org $c5deab ;map1
;org $C5DC2A ;map2
JSL init
Nop

;------------ this is the second init pointer to load Stalfos stuff
org $c5de25; map1
;org $C5dba4 ;map2
JSL correct6b

;------------this will shift objects to below slots, like the compass uses slot 2, but the lanmola segments need to be in a row
; therefore the objects inbetween slot 1 and slot 8 are moved to slots 9-16
org $C5D993 ;map1 
;org $c5d712;map2
JSL shiftSprites
NOP

;--------------------------objects d2-d3 must only follow the head (d1)
org $c58fd5; map1
;org $C59219;map2
JSL disableRandomMovement
Nop
NOP

;----------------Stalfos is weak so we need to give new hit points, damage he takes, starting x,y coordinates...
org $c5defa ;map1
;org $C5DC79; map2
JSL newStartValues

;------------this lets the segments follow the head
org $c590e0; map1
;org $c59324 ;map2
JSL lamnolaMovement

;---------------only the last segment can be hit, all other segments are invincible
org $c5467c; map1
;org $c5470f
JSL invincibleLamnola
NOP

org $CC818C ;map1
;org $cc8A3F ;map2
JSL disableThunderkill
org $CC8197 ;map1
; org $cc8a4a ;map2
JSL disableThunderkill


;-------VRAM transfer of Lanmola GFX tiles (D8 change Dodongo)
org $c57548 ; map1
;org $c57708 ;map2
JSL vramLamnolas
NOP

;--------palette change
org $c5dff6; map1
;org $c5dd75;map
JSL paletteLamnolas



;------------when Lanmola moves DOWN the tiles must be switched so the last segment has priority in the vram order. 
; Otherwise the head covers the following tiles which looks odd 
;------------it will also correct the distance, so each segments follow in 8 pixel distance
org $c5e444;org $C54F6C;map1
;org $C5e1c3;map2
JSL priorityUp ;reverse priority Lamnolas when going up


;-------------if Link hit a tile it would drift away so the segment order is destroyed
org $c591b7;map1
;org $c593fb; map2
JML disableRecoil

;--------- last d3 segment is defeated, the next d2 segment must become D3 
; also the speed is increased in case it is blue (4 segments left).
org $c58364
;org $C585A8
JSL defeatedSegment

;--------same as bugfix2
org $c59097; map1
;org $c592db
JSL bugfix2

;--------disable rewards like stop watch which makes this enemy a joke
org $C58702 ;map 1disable stop watch drop 
;org $c58946; map2
JSL disableReward





; free space
org $D0f300
;-----routines, only called once or rarely each frame-------------------------------------

vramLamnolas:
	STX $04
	STY $420B ;old code
	PHP
	Sep #$30
	; new Lamnolas tiles 11f300-11fff
	wait1:
	LDA $4212
	AND #$80
	BNE wait1
	wait2:
	LDA $4212
	AND #$80
	BEQ wait2
	LDA #$80
	STA $2115; Set VRAM transfer mode to word-access, increment by 1
	REP #$30
	LDA #$f300 ;
	STA $4302  ; Store Data offset into DMA source offset
	LDA #$1400 ;2800
	STA $2116 ;vram address
	LDA #$0700
	STA $4305 ; Store size of data block
	Sep #$30
	LDA #$18
	STA $4301
	LDA #$d1
	STA $4304 ; Store data Bank into DMA source bank´
	LDA #$01
	STA $4300
	STA $420b
	PLP
	RTL


init:
	AND #$00FF
	cmp #$00d0
	BCS $03
	STA $6b
	RTL	
	cmp #$00d1
	bne $03
	jmp initLamnolas
	cmp #$00d2
	bne $03
	jmp initLamnolas
	cmp #$00d3
	bne $03
	jmp initLamnolas
	cmp #$00d4
	bne $03
	jmp initLamnolas
	STA $6B
	RTL
	initLamnolas:
	LDA #$0023 ;Stalfos Object
	STA $6B
	RTL

newStartValues:
	SEP #$30
	STZ $20
	LDA $00
	cmp #$d0
	BCS $03
	jmp noNewStartValues
	LDA $0805
	CLC
	ADC #$08
	STA $0885
	ADC #$08
	STA $0905
	ADC #$08
	STA $0985
	ADC #$08
	STA $0a05
	ADC #$08
	STA $0a85
	ADC #$08
	STA $0b05
	ADC #$08
	STA $0b85
	LDA #$02 ;direction start
	STA $0835
	STA $084f
	STA $08b5
	STA $08cf
	STA $0935
	STA $094f
	STA $09b5
	STA $09cf
	STA $0a35
	STA $0a4f
	STA $0ab5
	STA $0acf
	STA $0B35
	STA $0b4f
	STA $0Bb5
	STA $0bcf
	LDA $0808 ;ystart
	STA $0888
	STA $0908
	STA $0988
	STA $0a08
	STA $0a88
	STA $0b08
	STA $0b88
	LDA #$08 ;hitpoints
	STA $0833
	STA $08b3
	STA $0933
	STA $09b3
	STA $0a33
	STA $0ab3
	STA $0b33
	STA $0bb3
	LDA #$04 ;hearts taken
	STA $0834
	STA $08b4
	STA $0934
	STA $09b4
	STA $0a34
	STA $0ab4
	STA $0b34
	STA $0bb4
	LDA #$88 ;speed
	STA $082b
	STA $08ab
	STA $092b
	STA $09ab
	STA $0a2b
	STA $0aab
	STA $0b2b
	STA $0bab
	noNewStartValues:
	RTL

shiftSprites:
	CMP #$d0
	BCS $06
	STA $00
	LDA $0007
	RTL
	PHA
	PHP
	Rep #$30
	LDA $7E71EB ;check save ram if already defeated
	AND #$4000
	BEQ $06
	PLP
	PLA
	LDA #$ff
	BRA $02
	PLP
	PLA
	cmp #$d1
	BEQ $06
	STA $00
	LDA $0007
	RTL
	PHP
	Rep #$30	
	PHX
	PHY
	LDY #$0C00
	LDA #$0800
	TCD
	nextShift:
	LDA $00
	CMP #$FFFF
	BEQ noShift
	PHB
	TDC
	TAX
	LDA #$007F
	MVN $7E7E
	PLB
	TYX
	TDC
	TAY
	LDA #$007f ; clear 
	PHB
	MVN $7e7e
	PLB
	TXA
	SEC
	SBC #$0080
	CMP #$0f00
	TAX
	BEQ endShift
	TXY
	noShift:
	TDC
	CLC
	ADC #$0080
	CMP #$0C00
	BEQ endShift
	TCD
	BRA nextShift
	endShift:
	LDA #$0800
	TCD
	PLY
	PLX
	PLP
	LDA #$D1
	STA $00
	LDA $0007
	RTL
	
;-----routines called on special events----------------------------------------------------	

disableRecoil:
	lda $0801
	cmp #$D0
	BCS $08
	LDY #$01
	LDA $43
	;JML $c593ff
	;JML $c593c9
	JML $c591bb ;map1
	JML $c59185 ;map1

invincibleLamnola:
	REP #$30
	LDY #$0001
	PHP
	SEP #$30
	LDA $00
	CMP #$d0
	BCS $02
	PLP
	RTL
	CMP #$d1
	BEQ invinc
	cmp #$d2
	BEQ invinc
	PLP
	RTL
	invinc:
	LDA $03Ee
	cmp #$07
	Beq noSFX
	cmp #$04
	BEQ noSFX
	cmp #$06
	BEQ noSFX	
	LDA #$07
	;JSL $C5C27B ; map2
	JSL $C5c248 ;map1
	noSFX:
	PLP
	LDY #$0000	
	RTL

defeatedSegment:
	LDA #$10
	STA $36
	LDA $00
	CMP #$d0
	BCS $01
	RTL
	PHP
	Rep #$20
	PHD
	LDA $00
	PHA
	tdc
	SEC
	SBC #$0080
	TCD
	LDA $00
	cmp #$d2d2
	BNE $05
	PLA
	STA $00
	BRA endDefeated
	cmp #$d1d1
	BNE $08
	PLA
	LDA #$d4d4 ;head only left
	STA $00
	BRA $01
	PLA
	endDefeated:
	PLD
	PLP
	; increase speed when blue
		LDA $0a00
		CMP #$d2
		BNE $01
		RTL
		LDA #$F8
		STA $082b
		STA $08ab
		STA $092b
		STA $09ab
		STA $0a2b
		STA $0aab
		STA $0b2b
		STA $0bab
	RTL

disableReward:
	PHA
	LDA $0800
	cmp #$D0
	BCS $06
	PLA
	CMP $C5866F,x ;map1
	;CMP $C588B3,x;map2
	RTL
	PLA
	SEC
	RTL

;-----routines called all 2-3 frames----------------------------------------------------	

disableRandomMovement:
	LDA $00
	CMP #$D2
	BEQ endDisableRandom
	CMP #$D3
	BEQ endDisableRandom

	STY $4F
	endDisableRandom:
	STZ $03ee
	LDA $7E292D
	RTL

paletteLamnolas:
	PHA
	LDA $00
	CMP #$d0
	BCS newpalette
	PLA
	STA $16
	LDA $1e
	RTL
	newpalette:
	JSR tilePointer	
	LDA $0a00
	CMP #$d2
	BNE $05
	PLA
	EOR #$0e
	Bra $03
	PLA
	EOR #$0c
	STA $16
	LDA $1e
	RTL
	tilePointer:
		php
		Sep #$30
		LDA $00
		CMP #$d0
		BCS $02
		PLP
		RTL
		LDA #$D0
		STA $19
		LDA #$FA
		STA $18
		LDA $00
		CMP #$d2
		BEQ tileTail
		CMP #$d3
		BEQ tileTail
		lda $35
		cmp #$01
		BNE $0a
		lda #$00
		clc
		adc $55
		STA $17
		jmp endPointer
		cmp #$02
		BNE $0a
		lda #$00
		clc
		adc $55
		STA $17
		jmp endPointer
		cmp #$04
		BNE $0a
		lda #$10
		clc
		adc $55
		STA $17
		jmp endPointer
		cmp #$08
		BNE $0a
		lda #$20
		clc
		adc $55	
		STA $17
		jmp endPointer
		tileTail:
		lda $35
		cmp #$01
		BNE $0a
		lda #$30
		clc
		adc $55
		STA $17
		jmp endPointer
		cmp #$02
		BNE $0a
		lda #$30
		clc
		adc $55
		STA $17
		jmp endPointer
		cmp #$04
		BNE $0a
		lda #$40
		clc
		adc $55
		STA $17
		jmp endPointer
		cmp #$08
		BNE $0a
		lda #$50
		clc
		adc $55
		STA $17
		endPointer:
		lda $55
		inc
		inc
		cmp #$08
		BNE $02
		LDA #$00
		STA $55
		PLP
		RTS


;--------routines called multiple times-----------------------------------------

correct6b:
	CMP #$00D0
	BCS correct
	ASL A
	ADC $6B
	TAX
	RTL
	correct:
	LDA #$0023 ;load stalfos pointer
	ASL A
	ADC #$0023
	TAX
	RTL



bugfix2:
	LDA $00
	cmp #$D0
	BCS $05
	LDA $4f
	STA $35
	RTL
	CMP #$D2
	BEQ reset
	CMP #$D3
	BEQ reset
	LDA $4f
	STA $35
	RTL
	reset:
	LDA $35
	STA $4f
	RTL

	
	




lamnolaMovement:
	LDA $00
	CMP #$D0
	BCS $05
	LDA $000F
	LSR A
	RTL	
	cmp #$D1
	beq connectHead
	cmp #$D2
	beq connectTail
	cmp #$D3
	beq connectTail
	jmp continueBugfix
	connectHead:
	LDA $4F
	cmp $52
	BNE $03 
	jmp continueBugfix
	STA $52
	LDA $d2
	cmp #$00
	BNE queueHead
	LDA $52
	STA $d2
	LDA $05
	STA $d3
	LDA $08
	STA $d4
	jmp continueBugfix
	queueHead:
	LDA $52
	STA $d6
	LDA $05
	STA $d7
	LDA $08
	STA $d8	
	BRA continueBugfix	
	connectTail:
	LDA $05
	CMP $53
	BNE continueBugfix
	LDA $08
	CMP $54
	BNE continueBugfix
	LDA $d2
	cmp #$00
	BNE queueTail
	LDA $52
	STA $35
	STA $4f
	LDA $00
	cmp #$d3
	BEQ deleteOld
	LDA $4f
	STA $D2
	LDA $53
	STA $D3
	LDA $54
	STA $D4
	bra deleteOld
queueTail:	
	LDA $52
	STA $35
	STA $4f
	LDA $00
	cmp #$d3
	BEQ deleteOld
	LDA $4f
	STA $D6
	LDA $53
	STA $D7
	LDA $54
	STA $D8
deleteOld:	
	LDA $56
	CMP #$00
	BNE $08
	STZ $52
	STZ $53
	STZ $54
	BRA continueBugfix
	LDA $56
	STA $52
	LDA $57
	STA $53
	LDA $58
	STA $54
	STZ $56
	STZ $57
	STZ $58
	continueBugfix:
	lda $00
	cmp #$d2
	BEQ bugfix
	cmp #$d3
	BEQ bugfix
	LDA $000F
	LSR A
	RTL
	bugfix:
	LDA $35
	LSR A
	RTL





priorityUp:
	lda $0800
	cmp #$d1
	BEQ $05
	LDA $0000AB
	RTL
	JSR correctMovement
	PHP
	REP #$30
	PHX
	PHY
	PHD
	LDA $0000
	PHA
	LDA #$0000
	STA $0000
	LDA #$0c00
	TCD
	noSegment:
	TDC
	SEC
	SBC #$0080
	TCD
	LDA $00
	AND #$00f0
	CMP #$00d0
	BNE noSegment
	LDA $0586
	AND #$00FF
	CLC
	ADC #$1d00
	TAX
newStartIndexY:
	dex
	dex
	LDA $0000,x
	AND #$00f0
	cmp #$0040
	beq $09	
	cmp #$0060
	beq $04
	dex
	dex
	bra newStartIndexY	
	dex
	dex
	TXY
	LDX #$1d00
newStartIndexX:
	inx
	inx
	LDA $0000,x
	AND #$00f0
	cmp #$0040
	beq $09	
	cmp #$0060
	beq $04
	inx
	inx
	bra newStartIndexX	
	dex
	dex	
	LDA #$0800
	TCD
	countSegmentsPriority:
	LDA $35
	AND #$00ff
	CMP #$0008
	beq exchange
	inx
	inx
	inx
	inx
	TDC
	CLC
	ADC #$0080
	TCD
	LDA $00
	AND #$00f0
	CMP #$00d0
	BEQ $03
	jmp endPriotityexchange
	BRA countSegmentsPriority	
	exchange:
	LDA $0000,x
	PHA
	LDA $0000,y
	STA $0000,x
	PLA 
	STA $0000,y
	INX
	INX
	INY
	INY
	LDA $0000,x
	PHA
	LDA $0000,y
	STA $0000,x
	PLA 
	STA $0000,y
	INX
	INX
	INY
	INY
	TYA
	SEC
	SBC #$0008
	TAY
	; check if next segment is lanmola tile
	newX:
	inx
	inx
	LDA $0000,x
	AND #$00f0
	cmp #$0040
	beq $09	
	cmp #$0060
	beq $04
	inx
	inx
	bra newX	
	dex
	dex	
	; check if next segment is lanmola tile
	LDA $0002
	PHA
	STX $0002
	TYX
	newY:
	INX
	INX
	LDA $0000,x
	AND #$00f0
	cmp #$0040
	beq $0d	
	cmp #$0060
	beq $08
	TXA
	SEC
	SBC #$0006
	TAX
	bra newY	
	dex
	dex	
	TXY
	LDX $0002
	PLA
	STA $0002
	STY $0000
	CPX $0000
	BCS endPriotityexchange
	LDA #$0000
	STA $0000
	TDC
	CLC
	ADC #$0080
	TCD
	LDA $00
	AND #$00f0
	CMP #$00d0
	BNE $03
	jmp countSegmentsPriority
	endPriotityexchange:
	PLA
	STA $0000
	PLD
	PLY
	PLX
	PLP
	LDA $0000AB
	RTL
; d3 is last tile, now we need to change priority.
	correctMovement:
		PHX
		PHD
		PHP
		REP #$30
		LDA #$0800
		LDX #$0000
		countSegments:
		TCD
		LDA $00
		AND #$00F0
		CMP #$00D0
		BNE endCountSegments
		INX
		TDC
		CLC
		ADC #$0080
		BRA countSegments
		endCountSegments:
		LDA #$0800
		TCD
		checkDirections:
		SEP #$30
		LDA $35 ;direction
		CMP $b5
		BNE nextSegment
		CMP #$01
		BNE checkleft
		LDA $05
		SEC
		SBC #$08 
		STA $85
		LDA $08
		STA $88
		BRA nextSegment
		checkleft:
		cmp #$02
		BNE checkdown
		LDA $05
		CLC
		ADC #$08 
		STA $85
		LDA $08
		STA $88
		BRA nextSegment
		checkdown:
		cmp #$04
		BNE checkup
		LDA $08
		SEC
		SBC #$08 
		STA $88
		LDA $05
		STA $85
		BRA nextSegment
		checkup:
		cmp #$08
		BNE nextSegment
		LDA $08
		CLC
		ADC #$08 
		STA $88
		LDA $05
		STA $85
		nextSegment:
		REP #$20
		TDC
		CLC
		ADC #$0080
		TCD
		DEX
		CPX #$01
		BNE checkDirections
		PLP
		PLD
		PLX 		
		RTS


disableThunderkill:
	STA $7E7419
	LDA $0800
	cmp #$D0
	BCS $01
	RTL
	LDA #$00
	STA $7E7419
	RTL




	


org $D0fa00 ;lamnolaHead side
db $40, $01, $40, $01, $40, $01, $40, $01
org $D0fa10 ;lamnolaHead down
db $60, $01, $60, $01, $60, $01, $60, $01
org $D0fa20 ;lamnolaHead up
db $48, $01, $48, $01, $48, $01, $48, $01
org $D0fa30 ;lamnola Tail side
db $42, $01, $44, $01, $46, $01, $44, $01
org $D0fa40 ;lamnola Tail down
db $62, $01, $64, $01, $66, $01, $64, $01
org $D0fa50 ;lamnola Tail up
db $4a, $01, $4c, $01, $4e, $01, $4a, $01


